@echo off

set MSC386=-nologo

rem max optimizations
set GLOBAL_O_FLAGS=-Ox					

rem UNICODE?
set MSC386=%MSC386% -DHAS_UNICODE=%MK_UNICODE%	

rem 32|64?
set MSC386=%MSC386% -DxxBIT=%MK_BITS%		

if "%MK_BITS%" == "32" (
	rem separate functions for linker
	set MSC386=%MSC386% -Gy		
) ELSE (
	set MSC386=%MSC386% -D_WIN64 -D_M_AMD64
	rem alignment warnings
	set MSC386=%MSC386% -wd4366 
	set MSC386=%MSC386% -wd4328 
)

if "%MK_DEBUG%" == "1" (
	rem no optimization, but add intrinsic functions
	set GLOBAL_O_FLAGS="-Od -Oi -RTCu -D_DEBUG" 	
) ELSE (
	rem max optimizations 
	set GLOBAL_O_FLAGS="-Ox -DNDEBUG"		
)

rem thread safe libraries
if "%MK_DEBUG%"  == "1" (
	set MSC386=%MSC386% -MTd	
) ELSE (
	set MSC386=%MSC386% -MT	
)

rem disable some warnings. Although we should be told.

rem no "security" checks
set MSC386=%MSC386% -GS-		
rem 64 bit porting warnings
set MSC386=%MSC386% -Wp64		


rem this top one we definately need to enable for LARGE_ARRAY support

rem conversion' conversion from '__int64' to smaller, possible loss of data
set MSC386=%MSC386% -wd4244 

rem expression' : signed/unsigned mismatch
set MSC386=%MSC386% -wd4018 

rem variable' : conversion from 'type' to 'type' of greater size
set MSC386=%MSC386% -wd4312 

rem unary minus operator applied to unsigned type, result still unsigned
set MSC386=%MSC386% -wd4146 

set MSC386=%MSC386% -wd4706
set MSC386=%MSC386% -wd4100
set MSC386=%MSC386% -wd4324
set MSC386=%MSC386% -wd4127
set MSC386=%MSC386% -wd4389
set MSC386=%MSC386% -wd4201
set MSC386=%MSC386% -wd4245

rem potentially uninitialized local variable used
set MSC386=%MSC386% -wd4701 
rem local variable is initialized but not referenced
set MSC386=%MSC386% -wd4189 
rem unreachable code
set MSC386=%MSC386% -wd4702 
rem nonstandard extension used : non-constant aggregate initializer
set MSC386=%MSC386% -wd4204 
rem nonstandard extension, function/data pointer conversion in expression
set MSC386=%MSC386% -wd4152 
rem 'type cast' : from function pointer to data pointer 
set MSC386=%MSC386% -wd4054 
rem 'type cast' : from data pointer to function pointer
set MSC386=%MSC386% -wd4055 
rem nonstandard extension used : bit field types other than int
set MSC386=%MSC386% -wd4214 
rem nonstandard extension used : zero-sized array in struct/union.
set MSC386=%MSC386% -wd4200 


rem extern "C" defaults to nothrow 
set MSC386=%MSC386% -EHsc		
rem unsigned char
set MSC386=%MSC386% -J			
rem debug info
set MSC386=%MSC386% -Zi			
rem use ebp
set MSC386=%MSC386% -Oy-		
rem WARNING level
set MSC386=%MSC386% -W3
rem tell Dyalog includes that these are APs
set MSC386=%MSC386% -DAP_BUILD=1

set MSC386=%MSC386% -DAPLVERSION=%MK_APLVERSION%
set MSC386=%MSC386% -DPROFILING=%MK_PROFILING%
set MSC386=%MSC386% -DDOS387

set INCLUDE=.;%INCLUDE%;%MK_SRCDIR%
set SRC=%1

set OUT=%OBJDIR%\%SRC:~0,-2%.obj

rem echo INCLUDE=%INCLUDE%
rem echo MSC386=%MSC386%

rem echo cl.exe -c -Fo%OUT% %OPT% %C_FLAGS% %O_FLAGS% %MSC386% %SRC%
         cl.exe -c -Fo%OUT% %OPT% %C_FLAGS% %O_FLAGS% %MSC386% %SRC%

