
//	Copyright (c) 1982 Dyadic Systems Limited	

/*
	Terminal control for 
	basic version 7				( V7 )
	system III and V			( BELL III)
	berkley 4.1 and 4.2			( bsd4.x )

*/

#include <machine.h>
#if	UNIX
#	include	<unistd.h>
#	include	<fcntl.h>
#endif//UNIX

#include <stdio.h>
#include <stdlib.h>
#include <gfns.h>

#if	AP_BUILD
#else //AP_BUILD
#	include <embed.h>
#endif//AP_BUILD

#include <unix.h>

#if	defined(FORTUNE)
#	define	BSD		// cntl o is used for flush 
#elif	defined(SUN)
#	define BELL
#elif	defined(PYRAMID)
#	define	BELL	// get BELL terminal driver in preference to BSD 
#	undef	BSD
#endif

#if	!(defined(PYRAMID) || defined(HP9000) || defined(DOSWIN))
#	include <sys/ioctl.h>
#endif

#ifdef	BELL

#include <termio.h>					// III 
#include <termios.h>					// III 
#include <unistd.h>
typedef struct termios TTY;
#define DYALOG_TCGET	TCGETS
#define DYALOG_TCSET	TCSETSW

#ifndef TIMEOV
#define TIMEOV 3
#endif	// TIMEOV 

#elif	defined(DOS)
	typedef struct {unsigned bufferd;} TTY;
#elif	WINCE
	typedef struct {unsigned bufferd;} TTY;
#elif	defined(WINDOWS3)
#	include	<io.h>
#	include	<windows.h>
	typedef DWORD TTY;
#else	// v7 BSD


#include <sgtty.h>				// V7	bsd4.x	

typedef struct					// V7	bsd4.x	
	{					// V7	bsd4.x	
	 struct sgttyb sg;			// V7	bsd4.x	
	 struct tchars tchar;			// V7	bsd4.x	
#	ifdef BSD
		 struct ltchars ltchar;		//	bsd4.x	
#	endif // BSD 
	} TTY;					// V7	bsd4.x	

#endif	// BELL 

#include <writloss.h>

static TTY	ttycontext,	// as we arrived			
		ttyapl,		// apl output mode			
		ttycbreak,	// apl input mode			
		ttyap,		// for aps (output tabs cr, lf)		
		ttyaout;	// almost raw - apl arbout, arbin mode	



unsigned	echoing,	// were we echoing on startup	
		tabson;		// are hard tabs turned on ?	
#if	defined(LINUX)
	speed_t
#else
	short
#endif//defined(LINUX)
		ospeed;		// output speed for termcap	
int		piped;		// multi-way flag:		
				//	0	stdin is tty	
				//	+ve	fd for /dev/tty	
				// 	-1	no tty at all	

static	char my_ttyname[32] = "";

#ifdef	INTERRUPTS
UCH tty_weak, tty_strong; // to communicate with input map setup 
#endif	// INTERRUPTS 

int ismytty(int fd)
{
	char *name = ttyname(fd);

	return name && 0 == strcmp(my_ttyname, name);
}

static unsigned have_initted_tty = 0;

void inittty(void)
{
	static int trystream[] = { 0, 2, 1, -1 };
	register int fd, i = 0;

	while((fd = trystream[i++]) >= 0)	// try to find a tty	
		 if(is_user_io(fd))
			break;			// bingo!		

	if(piped = fd)				// stdin is not a tty	
	{
		echoing = 1;			// then we want echo	
		if(fd < 0)			// no tty found yet	
#if	!defined(WATCOM) && !defined(MSC)
			if((fd = open("/dev/tty", 0)) < 0)
#endif//!defined(WATCOM)
				return;		// no terminal attached	
	}

	{
		char *name = ttyname(fd);

		if(name)strcpy(my_ttyname, name);
	}

	have_initted_tty = 1;
#ifdef BELL

	ioctl(fd, DYALOG_TCGET, &ttycontext);
	ttyapl = ttycontext;
	if(piped == -1)
		close(fd);
	else
	{
	 echoing = ECHO == (ttyapl.c_lflag&ECHO);// echo set ?		
	 ospeed = ttyapl.c_cflag;		// get ospeed for termcap 
	 tabson = TAB3 != (ttyapl.c_oflag&TAB3);// output tabs on ?	
	 ttyapl.c_lflag &= ~ECHO;		// echo off		
	 ttyapl.c_lflag &= ~ICANON;		// not a line at a time	
	 ttyapl.c_iflag &= ~ISTRIP;		// ensure 8 bits	
						// keyboard stuff strips 
#ifdef SUN
	// some sun terminals have probs with our preference for 8 data bits 
	{
		UCH *aplbits;

		aplbits = (void *)getenv("APLBITS");	// APLBITS env var	
		if (
			aplbits &&		// var is set and ...	
			*aplbits == '7'		// has value 7		
		)
			ttyapl.c_iflag |= ISTRIP;	// set ISTRIP	
	}
#endif // SUN 

#ifdef	INTERRUPTS
	 if(tty_weak)				// has been specified?  
		ttyapl.c_cc[VINTR] = tty_weak;	// set weak intr char	
	 if(tty_strong)
		ttyapl.c_cc[VQUIT] = tty_strong;// set strong intr char	
#endif	// INTERRUPTS 

	memset					// get back most ^ chars
		(
		ttyapl.c_cc + VEOF
	,	0
	,	NCCS - VEOF
		);
	 ttyapl.c_cc[VMIN] = 1;			// one char at a time	
	 ttyapl.c_cc[VTIME] = TIMEOV;		// time out value	
	 ttyapl.c_iflag &= ~(INLCR|IGNCR|ICRNL);// true tabs, separate CR LF 
	}

	ttycbreak = ttyapl;
	ttyap = ttycbreak;
	ttyap.c_oflag &= ~(TABDLY|ONLCR|OCRNL);// true tabs, separate CR LF 
	ttyaout = ttyap;
	ttyaout.c_lflag &= ~ISIG;		// disable interrupts	

#elif	defined(DOS)
	echoing = 1;
#elif	WINCE
	echoing = 1;
#elif	defined(WINDOWS3)
	{
	if
		(
		GetConsoleMode((HANDLE)_get_osfhandle(fd), &ttycontext)
		)
		{
		binary_file(_get_osfhandle(fd));

		ttyapl = ttycontext;
		ttyapl |= 
			(
			ENABLE_LINE_INPUT
		|	ENABLE_ECHO_INPUT
		|	ENABLE_PROCESSED_INPUT
			);
		ttycbreak = ttyaout = ttyapl;
		echoing = 0;
		}
	else
		echoing = 1;
	}
#else	//v7 BSD
	ioctl(fd, TIOCGETP, &ttycontext.sg);
	ioctl(fd, TIOCGETC, &ttycontext.tchar);

#ifdef	BSD
	ioctl(fd, TIOCGLTC, &ttycontext.ltchar);		// BSD4.x 
	ttyapl = ttycontext;					// BSD4.x 
	ttyapl.ltchar.t_suspc  = -1;	/* we want cntl z */	/* BSD4.x */
	ttyapl.ltchar.t_dsuspc = -1;	/* we want cntl y */	/* BSD4.x */
	ttyapl.ltchar.t_rprntc = -1;	/* for completeness*/	/* BSD4.x */
	ttyapl.ltchar.t_werasc = -1;	/* we want cntl w */	/* BSD4.x */
	ttyapl.ltchar.t_lnextc = -1;	/* we want cntl v */	/* BSD4.x */
	ttyapl.ltchar.t_flushc = -1;	/* we want cntl o */	/* BSD4.x */
#else	//~BSD 
	ttyapl = ttycontext;
#endif	// BSD 

	if(piped == -1)
		close(fd);
	ospeed = ttyapl.sg.sg_ospeed;
#ifdef	INTERRUPTS
	if(tty_weak)				// has been specified?  
		ttyapl.??? = tty_weak;	// set weak intr char	
	if(tty_strong)
		ttyapl.??? = tty_strong;	// set strong intr char	
#endif	// INTERRUPTS 
	
	i = ttyapl.sg.sg_flags;

	if(piped == 0)
	{
		echoing = ECHO == (i&ECHO);
		tabson = XTABS != (i&XTABS);
		i &= ~ECHO;		//	turn off echo		
		ttyapl.sg.sg_flags = i;
	}

	i &= ~XTABS;			//	turn on true tabs	
	i &= ~CRMOD;			//	separate linefeed and cr
	i |= CBREAK;			//	turn on cbreak		
	ttycbreak = ttyapl;
	ttycbreak.sg.sg_flags = i;
	ttyaout = ttyap = ttycbreak;
	ttycbreak.sg.sg_erase = -1;	// no erase character for PERQ	

#endif	// BELL 
}

static void term(TTY *tty);
static void force(TTY *tty, int pipe);

void termcbreak(void)
{
term(&ttycbreak);
}

void termap(int pipe)
{
force(&ttyap,pipe);
}

void termaout(int pipe)
{
force(&ttyaout,pipe);
}

void termapl(void)
{
term(&ttyapl);
}

void forceapl(int pipe)
{
force(&ttycontext,pipe);	// reset it for sure 
termapl();			// reset it if input is from a terminal 
}

void termcontext(void)
{
if(have_initted_tty)term(&ttycontext);
}

static void term(TTY *tty)
{
#if	1 == _CONSOLE
	return;				// no input mechanism
#elif	GUI
#	if	defined(WINDOWS3)
#		if	WINCE || _CONSOLE || AP_BUILD || APL_IME
			return;		// not applicable
#		else  //WINCE || _CONSOLE || AP_BUILD || APL_IME
			if (0 == RuntimeIsConsole())
				return;
#		endif //WINCE || _CONSOLE || AP_BUILD || APL_IME
#	elif	XAPL
#	endif //defined(WINDOWS3) || XAPL
#endif
	switch(piped)
	{
	case -1:			// no tty attached anywhere	
		return;
	case 0:				// stdin is a tty		
		force(tty, 0);
	default:			// 'piped' is an fd for the tty	
		break;
	}
}

static void force(TTY *tty, int pipe)
{
#if	1 == _CONSOLE
	return;				// no input mechanism
#elif	GUI
#	if	defined(WINDOWS3)
#		if	WINCE || _CONSOLE || AP_BUILD || APL_IME
			return;		// not applicable
#		else  //WINCE || _CONSOLE || AP_BUILD || APL_IME
			if (0 == RuntimeIsConsole())
				return;
#		endif //WINCE || _CONSOLE || AP_BUILD || APL_IME
#	elif	XAPL
#	endif //defined(WINDOWS3) || XAPL
#endif

#ifdef	BELL

ioctl(pipe,DYALOG_TCSET,tty);			// III 

#elif	defined(DOS)
#elif	WINCE
#elif	defined(WINDOWS3)
	{
	SetConsoleMode((HANDLE)_get_osfhandle(pipe), *tty);
	}
#else

ioctl(pipe,TIOCSETN,&tty->sg);			// V7	bsd4.x	
ioctl(pipe,TIOCSETC,&tty->tchar);		// V7	bsd4.x	

#ifdef	BSD
ioctl(pipe,TIOCSLTC,&tty->ltchar);		//	bsd4.x	
#endif	// BSD 


#endif	// BELL 
}

int tty_size(int *height, int *width)
	{
#if	defined(TIOCGWINSZ)
	struct winsize size;
	int ret = ioctl
		(
		piped
	,	TIOCGWINSZ
	,	(char *)&size
		);
	if(0 == ret)
		{
		*height = size.ws_row;
		*width = size.ws_col;
		}
#else //defined(TIOCGWINSZ)
	int ret = -1;		// failure; may need to set errno but not yet
#endif//defined(TIOCGWINSZ)
	return ret;
	}


//	Copyright (c) 1982 Dyadic Systems Limited	

